#version 150 core

layout( points ) in;
//layout(triangle_strip, max_vertices = 14) out;
layout( line_strip, max_vertices = 18 ) out;

in VERT_OUT {
  vec3 drawColor;

  int  drawBoundingBoxFlag;
  vec4 boundingBox[ 8 ];

  int  drawDirectionFlag;
  vec4 position;
  vec4 direction;

  int  drawPointFlag;
  vec4 point;
}
geom_in[ 1 ];

out vec3 drawColor;

/*
   5 _______ 4
   /|      /|
1 /_|____ /0|
 |  |____|__|
 | /6    | / 7
 |/______|/
3         2
  y|
   |
   |___ x
  /
z/
*/

void main() {
  drawColor = geom_in[ 0 ].drawColor;

  if ( geom_in[ 0 ].drawBoundingBoxFlag == 1 ) {
    gl_Position = geom_in[ 0 ].boundingBox[ 6 ];
    EmitVertex();
    gl_Position = geom_in[ 0 ].boundingBox[ 5 ];
    EmitVertex();
    gl_Position = geom_in[ 0 ].boundingBox[ 1 ];
    EmitVertex();
    gl_Position = geom_in[ 0 ].boundingBox[ 3 ];
    EmitVertex();
    gl_Position = geom_in[ 0 ].boundingBox[ 2 ];
    EmitVertex();
    gl_Position = geom_in[ 0 ].boundingBox[ 0 ];
    EmitVertex();
    gl_Position = geom_in[ 0 ].boundingBox[ 4 ];
    EmitVertex();
    gl_Position = geom_in[ 0 ].boundingBox[ 7 ];
    EmitVertex();
    gl_Position = geom_in[ 0 ].boundingBox[ 6 ];
    EmitVertex();
    gl_Position = geom_in[ 0 ].boundingBox[ 3 ];
    EmitVertex();
    gl_Position = geom_in[ 0 ].boundingBox[ 1 ];
    EmitVertex();
    gl_Position = geom_in[ 0 ].boundingBox[ 0 ];
    EmitVertex();
    gl_Position = geom_in[ 0 ].boundingBox[ 2 ];
    EmitVertex();
    gl_Position = geom_in[ 0 ].boundingBox[ 7 ];
    EmitVertex();
    gl_Position = geom_in[ 0 ].boundingBox[ 4 ];
    EmitVertex();
    gl_Position = geom_in[ 0 ].boundingBox[ 5 ];
    EmitVertex();
    EndPrimitive();
  }

  if ( geom_in[ 0 ].drawDirectionFlag == 1 ) {
    gl_Position = geom_in[ 0 ].position;
    EmitVertex();
    gl_Position = geom_in[ 0 ].direction;
    EmitVertex();
    EndPrimitive();
  }

  // gl_Position = geom_in[0].boundingBox[3];
  // EmitVertex();
  // gl_Position = geom_in[0].boundingBox[2];
  // EmitVertex();
  // gl_Position = geom_in[0].boundingBox[6];
  // EmitVertex();
  // gl_Position = geom_in[0].boundingBox[7];
  // EmitVertex();
  // gl_Position = geom_in[0].boundingBox[4];
  // EmitVertex();
  // gl_Position = geom_in[0].boundingBox[2];
  // EmitVertex();
  // gl_Position = geom_in[0].boundingBox[0];
  // EmitVertex();
  // gl_Position = geom_in[0].boundingBox[3];
  // EmitVertex();
  // gl_Position = geom_in[0].boundingBox[1];
  // EmitVertex();
  // gl_Position = geom_in[0].boundingBox[6];
  // EmitVertex();
  // gl_Position = geom_in[0].boundingBox[5];
  // EmitVertex();
  // gl_Position = geom_in[0].boundingBox[4];
  // EmitVertex();
  // gl_Position = geom_in[0].boundingBox[1];
  // EmitVertex();
  // gl_Position = geom_in[0].boundingBox[0];
  // EmitVertex();
  //EndPrimitive();
}
