#version 150 core
#extension GL_ARB_explicit_attrib_location : enable

layout( location = 0 ) in vec3 inVertex;
layout( location = 1 ) in vec3 inTextureCoord;
layout( location = 2 ) in vec3 inNormal;
layout( location = 3 ) in vec3 inTangent;

uniform mat4 modelViewProjectionMatrix;
uniform mat3 normalMatrix;

out vec2 textureCoord;
out mat3 tbnMatrix;

void main() {
  gl_Position  = modelViewProjectionMatrix * vec4( inVertex, 1.0f );
  textureCoord = inTextureCoord.xy;

  // создаем матрицу перевода направления в координаты пространства мира
  vec3 wsNormal    = normalize( normalMatrix * inNormal );
  vec3 wsTangent   = normalize( normalMatrix * inTangent );
  vec3 wsBitangent = normalize( cross( wsNormal, wsTangent ) );
  tbnMatrix        = mat3( wsTangent, wsBitangent, wsNormal );
}
