#version 150
#extension GL_ARB_explicit_attrib_location : enable
layout( location = 0 ) in vec3 inVertex;
layout( location = 1 ) in vec3 inTextureCoord;

uniform mat4 modelViewProjectionMatrix;
uniform vec2 screenSize;

out vec2 textureCoord;

void main() {
  vec4 ssPosition  = modelViewProjectionMatrix * vec4( inVertex, 1.0f );
  vec2 ndcPosition = ( ssPosition.xy / screenSize ) * 2.0f - 1.0f;
  gl_Position      = vec4( ndcPosition, 0.0f, 1.0f );
  textureCoord     = inTextureCoord.xy;
}
