#version 120

attribute vec3 inVertex;
attribute vec3 inTextureCoord;
attribute vec3 inNormal;
attribute vec3 inTangent;

uniform mat4 modelViewProjectionMatrix;
uniform mat3 normalMatrix;

varying vec2 textureCoord;
varying mat3 tbnMatrix;

void main() {
  gl_Position  = modelViewProjectionMatrix * vec4( inVertex, 1.0 );
  textureCoord = inTextureCoord.xy;

  // создаем матрицу перевода направления в координаты пространства мира
  vec3 wsNormal    = normalize( normalMatrix * inNormal );
  vec3 wsTangent   = normalize( normalMatrix * inTangent );
  vec3 wsBitangent = normalize( cross( wsNormal, wsTangent ) );
  tbnMatrix        = mat3( wsTangent, wsBitangent, wsNormal );
}
