#version 120

varying vec2 textureCoord;

uniform sampler2D textureAlbedo;
uniform vec3  screenGamma;
uniform float exposure;
uniform float alphaTestThreshold;
uniform float transparency;
uniform bool  isSky;

void main() {
  if ( isSky ) {
    return;
  }
  vec4  colorLinear = texture2D( textureAlbedo, textureCoord ).rgba;
  float alpha       = min( colorLinear.a, transparency );
  if ( alpha < alphaTestThreshold ) {
    discard;
  }
  vec3 mapped  = vec3( 1.0f ) - exp( -colorLinear.rgb * exposure );
  gl_FragColor = vec4( pow( mapped, screenGamma ), alpha );
}
